<?php

if (!defined('SMF'))
	die('Hacking attempt...');

function RateAdmin()
{
	global $context, $txt, $scripturl, $sourcedir;

	isAllowedTo('admin_forum');

	adminIndex('rate');

	loadTemplate('RateAdmin');

	$subActions = array(
		'defaultsettings' => 'DefaultSettings',
		'boardlist' => 'BoardList',
		'boardmodify' => 'BoardModify',
		'change' => 'Change',
	);

	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'defaultsettings';

	$context['page_title'] = $txt['rate_adminTitle'];
	$context['sub_action'] = $_REQUEST['sa'];

	$context['admin_tabs'] = array(
		'title' => $txt['rate_adminTitle'],
		'help' => $txt['rate_adminHelp'],
		'description' => $txt['rate_adminDesc'],
		'tabs' => array(
			'settings' => array(
				'title' => $txt['rate_defaultTitle'],
				'description' => $txt['rate_defaultDesc'],
				'href' => $scripturl . '?action=rateadmin;sa=defaultsettings',
				'is_selected' => $_REQUEST['sa'] == 'defaultsettings',
			),
			'boardlist' => array(
				'title' => $txt['rate_boardsTitle'],
				'description' => $txt['rate_boardsDesc'],
				'href' => $scripturl . '?action=rateadmin;sa=boardlist',
				'is_selected' => $_REQUEST['sa'] == 'boardlist' || $_REQUEST['sa'] == 'boardmodify',
			),
		),
	);

	require_once($sourcedir . '/Subs-Rate.php');

	$subActions[$_REQUEST['sa']]();
}

function DefaultSettings()
{
	global $txt, $scripturl, $context, $sourcedir, $modSettings, $db_prefix;

	require_once($sourcedir . '/ManageServer.php');

	$context['member_groups'] = array();

	$request = db_query("
		SELECT ID_GROUP, groupName
		FROM {$db_prefix}membergroups", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request)) {

		$checked = false;
		
		if(!empty($modSettings['rate_excludeGroups']) && in_array($row['ID_GROUP'], explode(',', $modSettings['rate_excludeGroups'])))
			$checked = true;
		 
		$context['member_groups'][] = array(
			'id' => $row['ID_GROUP'],
			'name' => $row['groupName'],
			'checked' => $checked,
		);
	}
	mysql_free_result($request);
	
	$config_vars = array(
			array('check', 'rate_enabled'),
			array('select', 'rate_againType', explode('|', $txt['rate_againTypeOp'])),
			array('int', 'rate_againWait'),
			array('select', 'rate_showMessageIndex', explode('|', $txt['rate_showMessageIndexOp'])),
		'',
	);

	if (isset($_GET['reset']))
		$context['reset'] = resetRate();

	if (isset($_GET['save']))
	{
		if (!empty($_POST['member_groups']) && is_array($_POST['member_groups']))
			$_POST['rate_excludeGroups'] = implode(',', $_POST['member_groups']);
		else
			$_POST['rate_excludeGroups'] = '';

		$save_vars = $config_vars;
		$save_vars[] = array('text', 'rate_excludeGroups');
		
		saveDBSettings($save_vars);
		redirectexit('action=rateadmin;sa=defaultsettings');
	}

	$context['post_url'] = $scripturl . '?action=rateadmin;sa=defaultsettings;save';
	$context['settings_title'] = $txt['rate_defaultTitle'];

	prepareDBSettingContext($config_vars);
}

function BoardList()
{
	global $txt, $context, $sourcedir, $cat_tree, $boards, $boardList, $db_prefix, $modSettings;

	if (!empty($_POST['changeBoards']) && !empty($_POST['quickChange']) && !empty($_POST['boards']) && is_array($_POST['boards']))
	{
		checkSession();

		foreach ($_POST['boards'] as $index => $board_id)
			$_POST['boards'][(int) $index] = (int) $board_id;

		if($_POST['quickChange'] == 1)
			$query = array(
					'column' => 'status',
					'value' => '0',
				);
		elseif($_POST['quickChange'] == 2)
			$query = array(
					'column' => 'status',
					'value' => '1',
				);
		elseif($_POST['quickChange'] == 3)
			$query = array(
					'column' => 'type',
					'value' => '0',
				);
		elseif($_POST['quickChange'] == 4)
			$query = array(
					'column' => 'type',
					'value' => '1',
				);
		else
			fatal_lang_error('rate_undefined_type');
			
		foreach($_POST['boards'] as $board) {

			$request = db_query("
				SELECT ID_BOARD
				FROM {$db_prefix}boards
				WHERE ID_BOARD = $board
				LIMIT 1", __FILE__, __LINE__);
			list ($return[$board]) = mysql_fetch_row($request);
			mysql_free_result($request);

			if(empty($return[$board])) {
				unset($return[$board]);
				continue;
			}

			$request = db_query("
				SELECT status
				FROM {$db_prefix}tr_setting
				WHERE ID_BOARD = $board
				LIMIT 1", __FILE__, __LINE__);
			list ($status[$board]) = mysql_fetch_row($request);
			mysql_free_result($request);				

			if(!isset($status[$board])) {
				db_query("
					INSERT INTO {$db_prefix}tr_setting
							(ID_BOARD, status)
					VALUES ($board, 1)", __FILE__, __LINE__);
			}

			db_query("
				UPDATE {$db_prefix}tr_setting
				SET $query[column] = $query[value]
				WHERE ID_BOARD = $board
				LIMIT 1", __FILE__, __LINE__);
		}
	}
	
	require_once($sourcedir . '/Subs-Boards.php');
	
	getBoardTree();
	
	$context['categories'] = array();
	foreach ($cat_tree as $catid => $tree)
	{
		$context['categories'][$catid] = array(
			'name' => &$tree['node']['name'],
			'id' => &$tree['node']['id'],
			'boards' => array()
		);
		foreach ($boardList[$catid] as $boardid)
		{
			$status = $type = 0;
			$request = db_query("
				SELECT status, type
				FROM {$db_prefix}tr_setting
				WHERE ID_BOARD = $boardid
				LIMIT 1", __FILE__, __LINE__);
			list ($status, $type) = mysql_fetch_row($request);
			mysql_free_result($request);
	
			$context['categories'][$catid]['boards'][$boardid] = array(
				'id' => &$boards[$boardid]['id'],
				'name' => &$boards[$boardid]['name'],
				'description' => &$boards[$boardid]['description'],
				'child_level' => &$boards[$boardid]['level'],
				'status' => !empty($status) ? 1 : 0,
				'type' => !empty($type) ? 1 : 0,
			);
		}
	}

	$context['sub_template'] = 'board_list';
}

function BoardModify()
{
	global $txt, $db_prefix, $context, $func;

	if(empty($_POST['modify_board'])) {

		$_REQUEST['id'] = (int)$_REQUEST['id'];

		if(empty($_REQUEST['id']))
			fatal_lang_error('rate_undefined_id');

		$context['boardInfo'] = getRatingInfo($_REQUEST['id']);

		$context['member_groups'] = array();
	
		$request = db_query("
			SELECT ID_GROUP, groupName
			FROM {$db_prefix}membergroups", __FILE__, __LINE__);
		while ($row = mysql_fetch_assoc($request)) {

		$checked = false;
		
			if(!empty($context['boardInfo']['excludeGroups']) && in_array($row['ID_GROUP'], explode(',', $context['boardInfo']['excludeGroups'])))
				$checked = true;
		 
			$context['member_groups'][] = array(
				'id' => $row['ID_GROUP'],
				'name' => $row['groupName'],
				'checked' => $checked,
			);
		}
		mysql_free_result($request);

		$context['sub_template'] = 'board_modify';
	}
	else {

		checkSession();

		$_POST['board_id'] = (int) $_POST['board_id'];
		
		if (empty($_POST['board_id']))
			fatal_lang_error('rate_undefined_id');

		if (!empty($_POST['member_groups']) && is_array($_POST['member_groups']))
			$_POST['excludeGroups'] = implode(',', $_POST['member_groups']);
		else
			$_POST['excludeGroups'] = '';
			
		$modifiedInfo = array(
				'id' => $_POST['board_id'],
				'status' => !empty($_POST['status']) ? 1 : 0,
				'excludeGroups' => $_POST['excludeGroups'],
			);

		$board_fields = array();
		$board_fields[] = "status = '$modifiedInfo[status]'";
		$board_fields[] = "excludeGroups = '$modifiedInfo[excludeGroups]'";

		db_query("
			UPDATE {$db_prefix}tr_setting
			SET " . implode(', ', $board_fields) . "
			WHERE ID_BOARD = $modifiedInfo[id]
			LIMIT 1", __FILE__, __LINE__);

		redirectexit('action=rateadmin;sa=boardlist');
	}
}

function Change()
{
	global $db_prefix;

	checkSession('get');

	$_REQUEST['id'] = (int)$_REQUEST['id'];

	if(empty($_REQUEST['id']))
		fatal_lang_error('rate_undefined_id');

	$request = db_query("
		SELECT ID_BOARD
		FROM {$db_prefix}boards
		WHERE ID_BOARD = $_REQUEST[id]
		LIMIT 1", __FILE__, __LINE__);
	list ($board) = mysql_fetch_row($request);
	mysql_free_result($request);
	
	if(empty($board))
		fatal_lang_error('rate_undefined_board');
			
	if(empty($_REQUEST['type']) || !in_array($_REQUEST['type'], array('status', 'type')))
		fatal_lang_error('rate_undefined_type');
	
	$request = db_query("
		SELECT $_REQUEST[type]
		FROM {$db_prefix}tr_setting
		WHERE ID_BOARD = $_REQUEST[id]
		LIMIT 1", __FILE__, __LINE__);
	list ($change) = mysql_fetch_row($request);
	mysql_free_result($request);

	if(isset($change)) {

		$change = (int) $change;
		$change = ($change == 1) ? 0 : 1 ;

		db_query("
			UPDATE {$db_prefix}tr_setting
			SET $_REQUEST[type] = $change
			WHERE ID_BOARD = $_REQUEST[id]
			LIMIT 1", __FILE__, __LINE__);	
	}
	else {
		db_query("
			INSERT INTO {$db_prefix}tr_setting
				(ID_BOARD, status)
			VALUES ($_REQUEST[id], 1)", __FILE__, __LINE__);		
	}

	redirectexit('action=rateadmin;sa=boardlist');
}

function RateLog()
{
	global $txt, $db_prefix, $context, $log_request, $scripturl, $ID_MEMBER;

	$topic_id = !empty($_REQUEST['id']) ? (int) $_REQUEST['id'] : 0;

	isAllowedTo('moderate_forum');

	if(empty($topic_id))
		fatal_lang_error('rate_undefined_id', false);
		
	$request = db_query("
		SELECT ID_TOPIC
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topic_id
		LIMIT 1", __FILE__, __LINE__);
	list ($check) = mysql_fetch_row($request);
	mysql_free_result($request);

	if(empty($check))
		fatal_lang_error('rate_undefined_id', false);

	loadTemplate('rateadmin');
	$context['sub_template'] = 'rate_log';

	$context['page_title'] = $txt['rate_logTitle'];
	
	$sort_methods = array(
		'user' =>  array(
			'down' => 'm.realName ASC',
			'up' => 'm.realName DESC'
		),
		'group' =>  array(
			'down' => 'mg.groupName ASC',
			'up' => 'mg.groupName DESC'
		),
		'rate' => array(
			'down' => 'rl.rate ASC',
			'up' => 'rl.rate DESC'
		),
		'time' => array(
			'down' => 'rl.time ASC',
			'up' => 'rl.time DESC'
		),
	);

	$context['columns'] = array(
		'user' => array(
			'width' => '25%',
			'label' => $txt[35],
			'sortable' => true
		),
		'group' => array(
			'width' => '20%',
			'label' => $txt[87],
			'sortable' => true
		),
		'rate' => array(
			'width' => '15%',
			'label' => $txt['rate_logRate'],
			'sortable' => true
		),
		'time' => array(
			'width' => '40%',
			'label' => $txt['rate_logTime'],
			'sortable' => true
		),
	);

	if (!isset($_REQUEST['sort']) || !isset($sort_methods[$_REQUEST['sort']]))
		$_REQUEST['sort'] = $_REQUEST['desc'] = 'time';
	
	foreach ($context['columns'] as $col => $dummy)
	{
		$context['columns'][$col]['selected'] = $col == $_REQUEST['sort'];
		$context['columns'][$col]['href'] = $scripturl . '?action=ratelog;id=' . $topic_id . ';sort=' . $col;

		if (!isset($_REQUEST['desc']) && $col == $_REQUEST['sort'])
			$context['columns'][$col]['href'] .= ';desc';

		$context['columns'][$col]['link'] = '<a href="' . $context['columns'][$col]['href'] . '">' . $context['columns'][$col]['label'] . '</a>';
	}

	$context['sort_by'] = $_REQUEST['sort'];
	$context['sort_direction'] = !isset($_REQUEST['desc']) ? 'down' : 'up';

	$request = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}tr_log
		WHERE ID_TOPIC = $topic_id", __FILE__, __LINE__);
	list ($totalLogs) = mysql_fetch_row($request);
	mysql_free_result($request);

	$context['page_index'] = constructPageIndex($scripturl . '?action=ratelog;id=' . $topic_id . ';sort=' . $_REQUEST['sort'] . (isset($_REQUEST['desc']) ? ';desc' : ''), $_REQUEST['start'], $totalLogs, 20);
	$context['start'] = $_REQUEST['start'];

	$log_request = db_query("
		SELECT rl.ID_MEMBER, rl.rate, rl.time, m.realName,
			IFNULL(mg.groupName, '') AS member_group, IFNULL(pg.groupName, '') AS post_group
		FROM {$db_prefix}tr_log AS rl
			LEFT JOIN {$db_prefix}members AS m ON (m.ID_MEMBER = rl.ID_MEMBER)
			LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = m.ID_POST_GROUP)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = m.ID_GROUP)
		WHERE rl.ID_TOPIC = $topic_id
		ORDER BY " . $sort_methods[$_REQUEST['sort']][$context['sort_direction']] . "
		LIMIT $context[start], 20", __FILE__, __LINE__);

	$context['get_logs'] = 'getLogEntry';
}

function getLogEntry($reset = false)
{
	global $scripturl, $log_request, $txt, $context;

	if ($log_request == false)
		return false;

	if (!($row = mysql_fetch_assoc($log_request)))
		return false;

	$output = array(
		'id' => $row['ID_MEMBER'],
		'name' => $row['realName'],
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
		'member_group' => $row['member_group'],
		'post_group' => $row['post_group'],
		'rate' => $row['rate'],
		'time' => !empty($row['time']) ? timeformat($row['time']) : '-',
	);

	return $output;
}

?>