<?php

function Rate()
{
	global $db_prefix, $ID_MEMBER;

	$rateOptions['member'] = $ID_MEMBER;
	$rateOptions['topic'] = !empty($_POST['topic']) ? (int) $_POST['topic'] : 0;
	$rateOptions['board'] = !empty($_POST['board']) ? (int) $_POST['board'] : 0;
	$rateOptions['rate'] = !empty($_POST['rate']) ? (int) $_POST['rate'] : 0;

	foreach($rateOptions as $option)
		if(empty($option))
			fatal_lang_error('rate_missing_info', false);

	if($rateOptions['rate'] > 5 || $rateOptions['rate'] < 1)
		fatal_lang_error('rate_not_in_range', false);

	$rateOptions['time'] = time();

	$rateOptions['type'] = canRate($rateOptions['board'], $rateOptions['topic']);

	if(!$rateOptions['type'])
		fatal_lang_error('rate_not_allowed');

	if($rateOptions['type'] == 1)
		db_query("
			UPDATE {$db_prefix}tr_log
			SET rate = $rateOptions[rate],
				time = $rateOptions[time]
			WHERE ID_TOPIC = $rateOptions[topic]
				AND ID_MEMBER = $ID_MEMBER
			LIMIT 1", __FILE__, __LINE__);
	else
		db_query("
			INSERT INTO {$db_prefix}tr_log
				(ID_MEMBER, ID_TOPIC, rate, time)
			VALUES ($rateOptions[member], $rateOptions[topic], $rateOptions[rate], $rateOptions[time])", __FILE__, __LINE__);

	redirectexit('topic=' . $rateOptions['topic'] . '.0');
}

function getRatingAverage($topic_id = null)
{
	global $db_prefix;

	$topic_id = (int) $topic_id;
	
	if(empty($topic_id))
		return 0;

	$request = db_query("
		SELECT ID_TOPIC
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $topic_id
		LIMIT 1", __FILE__, __LINE__);
	list ($check) = mysql_fetch_row($request);
	mysql_free_result($request);

	if(empty($check))
		return 0;

	$request = db_query("
		SELECT rate
		FROM {$db_prefix}tr_log
		WHERE ID_TOPIC = $topic_id", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$return[] = $row['rate'];
	}
	mysql_free_result($request);

	if(!empty($return))
		$average = round(array_sum($return) / count($return));
	else
		return 0;

	return $average;
}

function getRatingInfo($board_id = null)
{
	global $db_prefix;

	$request = db_query("
		SELECT ID_BOARD, status, type, excludeGroups
		FROM {$db_prefix}tr_setting
		WHERE ID_BOARD = $board_id
		LIMIT 1", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$return = array(
			'id' => $row['ID_BOARD'],
			'status' => $row['status'],
			'type' => $row['type'],
			'excludeGroups' => $row['excludeGroups'],
		);
	}
	mysql_free_result($request);

	return $return;
}

function getRatingStatus($board_id = null)
{
	global $db_prefix, $modSettings, $user_info;

	if(empty($modSettings['rate_enabled']))
		return false;

	$board_id = (int) $board_id;
	
	$result = db_query("
		SELECT status
		FROM {$db_prefix}tr_setting
		WHERE ID_BOARD = $board_id
		LIMIT 1", __FILE__, __LINE__);
	list ($check) = mysql_fetch_row($result);
	mysql_free_result($result);

	if(empty($check))
		return false;
	else
		return true;
}

function getUserRating($topic_id = null)
{
	global $db_prefix, $ID_MEMBER;

	$request = db_query("
		SELECT rate
		FROM {$db_prefix}tr_log
		WHERE ID_TOPIC = $topic_id
			AND ID_MEMBER = $ID_MEMBER
		LIMIT 1", __FILE__, __LINE__);
	list ($check) = mysql_fetch_row($request);
	mysql_free_result($request);

	if(empty($check))
		return 0;
	else
		return $check;
}

function canRate($board_id = null, $topic_id = null)
{
	global $db_prefix, $modSettings, $user_info, $ID_MEMBER;

	if(empty($modSettings['rate_enabled']))
		return false;

	if($user_info['is_guest'])
		return false;

	$board_id = (int) $board_id;

	if(empty($board_id))
		return false;

	$type = 3;

	$result = array();
	$result = getRatingInfo($board_id);

	if(empty($result['status']))
		return false;

	if(!empty($topic_id)) {

		$topic_id = (int) $topic_id;

		$request = db_query("
			SELECT locked
			FROM {$db_prefix}topics
			WHERE ID_TOPIC = $topic_id
			LIMIT 1", __FILE__, __LINE__);
		list ($check['lock']) = mysql_fetch_row($request);
		mysql_free_result($request);

		if(!empty($check['lock']))
			return false;

		$request = db_query("
			SELECT rate, time
			FROM {$db_prefix}tr_log
			WHERE ID_TOPIC = $topic_id
				AND ID_MEMBER = $ID_MEMBER
			LIMIT 1", __FILE__, __LINE__);
		list ($check['rate'], $check['time']) = mysql_fetch_row($request);
		mysql_free_result($request);

		if(!empty($check['rate']))
			if(empty($modSettings['rate_againType']))
				return false;
			else
				if(!empty($modSettings['rate_againWait']) && (time() - $check['time'] < (int) ($modSettings['rate_againWait'] * 3600)))
					return false;
				else
					if($modSettings['rate_againType'] == 1)
						$type = 1;
					elseif($modSettings['rate_againType'] == 2)
						$type = 2;
	}

	if(empty($result['type'])) {

		if(!empty($modSettings['rate_excludeGroups'])) {

			$excludeGroups = explode(',', $modSettings['rate_excludeGroups']);

			foreach($user_info['groups'] as $group) {
				if(in_array($group, $excludeGroups))
					return false;
			}
		}
	}
	else {

		if(!empty($result['excludeGroups'])) {

			$excludeGroups = explode(',', $result['excludeGroups']);

			foreach($user_info['groups'] as $group) {
				if(in_array($group, $excludeGroups))
					return false;
			}
		}
	}

	return $type;
}

function resetRate()
{
	global $db_prefix;

		db_query("
			TRUNCATE {$db_prefix}tr_log", __FILE__, __LINE__);

	$log['success'] = true;
	return $log;
}

?>